package com.utopiaindustries.qualitycontrol.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.utopiaindustries.qualitycontrol.R;
import com.utopiaindustries.qualitycontrol.models.LocationFloor;
import com.utopiaindustries.qualitycontrol.models.LocationUnit;

import java.util.List;

public class UnitAdapter extends ArrayAdapter<LocationUnit> {

    private final Context context;
    private final List<LocationUnit> items;

    public UnitAdapter(Context context, List<LocationUnit> items) {
        super(context, 0, items);
        this.context = context;
        this.items = items;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_items, parent, false);
        }

        LocationUnit item = items.get(position);

        TextView titleTextView = convertView.findViewById(R.id.item_text);

        titleTextView.setText(item.getTitle());

        return convertView;
    }
}
