package com.utopiaindustries.qualitycontrol.apiservice;

import com.utopiaindustries.qualitycontrol.models.QualityControlResponse;
import com.utopiaindustries.qualitycontrol.models.QualitySaveResponse;
import com.utopiaindustries.qualitycontrol.viewmodels.QualityControl;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

public interface ApiService {

    /*@GET("rest/uic/inspection-report")
    Call<List<Container>> fetchAllReports(
            @Query("username") String username
    );*/

    @GET("rest/uic/quality-control/get-quality-control-data")
    Call<QualityControlResponse> getQualityControlData();


    @POST("rest/uic/quality-control/save-quality-control")
    Call<QualitySaveResponse> saveQualityControlReport(
            @Body QualityControl request
    );

    @POST("rest/authentication/authenticate-user")
    Call<Boolean> isUserAuthenticated(
            @Query("username") String username,
            @Query("password") String password,
            @Query("roles") String[] roles
    );
}
