package com.utopiaindustries.qualitycontrol.fragments;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.material.textfield.TextInputLayout;
import com.utopiaindustries.qualitycontrol.R;
import com.utopiaindustries.qualitycontrol.activities.HomeActivity;
import com.utopiaindustries.qualitycontrol.adapters.DepartmentItemAdapter;
import com.utopiaindustries.qualitycontrol.adapters.FloorAdapter;
import com.utopiaindustries.qualitycontrol.adapters.LocationSitesAdapter;
import com.utopiaindustries.qualitycontrol.adapters.UnitAdapter;
import com.utopiaindustries.qualitycontrol.helper.Helper;
import com.utopiaindustries.qualitycontrol.helper.Preference;
import com.utopiaindustries.qualitycontrol.models.Department;
import com.utopiaindustries.qualitycontrol.models.LocationFloor;
import com.utopiaindustries.qualitycontrol.models.LocationSite;
import com.utopiaindustries.qualitycontrol.models.LocationUnit;
import com.utopiaindustries.qualitycontrol.utils.ProgressDialogFragment;
import com.utopiaindustries.qualitycontrol.viewmodels.LoginViewModel;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.Objects;
import java.util.stream.Collectors;

public class HomeFragment extends Fragment implements DepartmentItemAdapter.OnItemClickListener {

    AutoCompleteTextView locationSiteTextview, unitTextview, floorTextview;
    TextInputLayout loc_input;
    TextView txtCurrentDate;
    LoginViewModel loginViewModel;
    Button nextButton;

    LocationSitesAdapter locationSitesAdapter;
    UnitAdapter unitAdapter;
    FloorAdapter floorAdapter;

    ArrayList<Department> departmentList = new ArrayList<>();
    ArrayList<LocationSite> locationSiteList = new ArrayList<>();

    ArrayList<LocationUnit> locationUnitList = new ArrayList<>();
    ArrayList<LocationUnit> locationUnitListFiltered = new ArrayList<>();

    ArrayList<LocationFloor> locationFloorList = new ArrayList<>();
    ArrayList<LocationFloor> locationFloorListFiltered = new ArrayList<>();

    EditText searchEditText;
    RecyclerView recyclerView;
    List<Department> filteredList;
    private DepartmentItemAdapter departmentItemAdapter;
    boolean isFromPrevious = false;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.fragment_home, container, false);

        initializeLayout(view);

        String date = new SimpleDateFormat("EEEE, MMM d, yyyy", Locale.getDefault()).format(new Date());
        txtCurrentDate.setText(date);

        locationSiteTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int position, long l) {
                //Log.e("onItemClick: ","--Site");
                LocationSite clickedItem = locationSiteList.get(position);
                unitTextview.setText(null);
                floorTextview.setText(null);

                //viewModel.setLocation(String.valueOf(clickedItem.getId()));
                Preference.setMyStringPref(Helper.project_file, Helper.locationSiteId, getActivity(), String.valueOf(clickedItem.getId()));
                Preference.setMyStringPref(Helper.project_file, Helper.locationSiteName, getActivity(), String.valueOf(clickedItem.getTitle()));

                if (!locationUnitList.isEmpty()) {
                    List<LocationUnit> filteredUnitItems = locationUnitList.stream()
                            .filter(item -> Objects.equals(item.getSiteId(), clickedItem.getId()))
                            .collect(Collectors.toList());

                    locationUnitListFiltered.clear();
                    locationUnitListFiltered.addAll(filteredUnitItems);
                    unitAdapter = new UnitAdapter(getActivity(), filteredUnitItems);
                    unitTextview.setAdapter(unitAdapter);

                }
            }
        });

        unitTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                //Log.e("onItemClick: ","--Unit");
                LocationUnit clickedItem = locationUnitListFiltered.get(position);
                floorTextview.setText(null);
                //viewModel.setUnit(String.valueOf(clickedItem.getId()));
                Preference.setMyStringPref(Helper.project_file, Helper.unitId, getActivity(), String.valueOf(clickedItem.getId()));
                Preference.setMyStringPref(Helper.project_file, Helper.unitName, getActivity(), String.valueOf(clickedItem.getTitle()));

                int targetSiteId = Integer.parseInt(Preference.getMyStringPref(Helper.project_file, Helper.locationSiteId, getActivity()));
                //Log.e("SiteId: ",""+targetSiteId);
                //Log.e("UnitId: ",""+clickedItem.getId());

                if (!locationFloorList.isEmpty()) {
                    List<LocationFloor> filteredFloorsList = locationFloorList.stream()
                            .filter(floor -> floor.getSiteId() == targetSiteId && Objects.equals(floor.getUnitId(), clickedItem.getId()))
                            .collect(Collectors.toList());

                    locationFloorListFiltered.clear();
                    locationFloorListFiltered.addAll(filteredFloorsList);
                    floorAdapter = new FloorAdapter(getActivity(), filteredFloorsList);
                    floorTextview.setAdapter(floorAdapter);

                }
            }
        });

        floorTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> adapterView, View view, int position, long l) {
                //Log.e("onItemClick: ","--Floor");
                LocationFloor clickedItem = locationFloorListFiltered.get(position);
                //viewModel.setFloor(String.valueOf(clickedItem.getId()));
                Preference.setMyStringPref(Helper.project_file, Helper.floorId, getActivity(), String.valueOf(clickedItem.getId()));
                Preference.setMyStringPref(Helper.project_file, Helper.floorName, getActivity(), String.valueOf(clickedItem.getTitle()));

            }
        });

        nextButton.setOnClickListener(v -> {
            if (getActivity() instanceof HomeActivity) {
                //viewModel.setFromViewModel(true);
                // Preference.setMyStringPref(Helper.project_file, Helper.InProcess, getActivity(), "true");
                String siteID = Preference.getMyStringPref(Helper.project_file, Helper.locationSiteId, getActivity());
                String unitId = Preference.getMyStringPref(Helper.project_file, Helper.unitId, getActivity());
                String departId = Preference.getMyStringPref(Helper.project_file, Helper.departmentId, getActivity());
                String floorId = Preference.getMyStringPref(Helper.project_file, Helper.floorId, getActivity());
                Log.e("AdapterData", "siteID: " + siteID + ", unitId: " + unitId +
                        ", departId: " + departId + ", floorId: " + floorId);

                if (isValidate(departId, siteID, unitId, floorId)) {

                    ((HomeActivity) getActivity()).navigateToFragment(new CuttingFragment(), true);

                    // Clear dropdown selections
                    searchEditText.setText(null);
                    locationSiteTextview.setText(null);
                    unitTextview.setText(null);
                    floorTextview.setText(null);
                }

            }
        });

        searchEditText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                filterList(s.toString());
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });

        return view;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

    }

    public void initializeLayout(View view) {

        //viewModel = new ViewModelProvider(requireActivity()).get(QualityControlViewModel.class);

        txtCurrentDate = view.findViewById(R.id.txt_current_date);
        locationSiteTextview = view.findViewById(R.id.location_textview);

        loc_input = view.findViewById(R.id.loc_input);

        unitTextview = view.findViewById(R.id.unit_textview);
        floorTextview = view.findViewById(R.id.floor_textview);
        nextButton = view.findViewById(R.id.btn_next);

        searchEditText = view.findViewById(R.id.searchEditText);

        recyclerView = view.findViewById(R.id.recyclerView);

        recyclerView.setVisibility(View.GONE);

        loginViewModel = new ViewModelProvider(getActivity()).get(LoginViewModel.class);

        loginViewModel.getLoadingState().observe(getActivity(), isLoading -> {

            if (isLoading != null && isLoading) {
                showProgressDialog();
            } else {
                dismissProgressDialog();
            }
        });

        loginViewModel.getErrorMessage().observe(getActivity(), errorResponse -> {
            Toast.makeText(getActivity(), errorResponse, Toast.LENGTH_SHORT).show();
        });

        loginViewModel.getUserLiveData().observe(getActivity(), qcResponse -> {
            if (qcResponse != null) {

                Helper.setPreferenceObject(getActivity().getApplicationContext(), qcResponse, "qcResponse");

                if (!qcResponse.getLocationSites().isEmpty()) {

                    //viewModel.setLocationSiteList(qcResponse.getLocationSites());
                    Helper.saveList(qcResponse.getLocationSites(), Helper.homeSite, getActivity());

                    locationSiteList.addAll(qcResponse.getLocationSites());

                    locationSitesAdapter = new LocationSitesAdapter(getActivity(), locationSiteList);
                    locationSiteTextview.setAdapter(locationSitesAdapter);
                    //locationSitesAdapter.notifyDataSetChanged();
                }

                if (!qcResponse.getDepartments().isEmpty()) {

                    // viewModel.setDepartmentList(qcResponse.getDepartments());
                    Helper.saveList(qcResponse.getDepartments(), Helper.homeDepartment, getActivity());

                    departmentList.addAll(qcResponse.getDepartments());
                    filteredList = new ArrayList<>(departmentList);

                    // Set up RecyclerView
                    departmentItemAdapter = new DepartmentItemAdapter(filteredList, this, searchEditText, recyclerView);
                    recyclerView.setLayoutManager(new LinearLayoutManager(getActivity()));
                    recyclerView.setAdapter(departmentItemAdapter);
                }

                if (!qcResponse.getLocationFloors().isEmpty()) {
                    // viewModel.setFloorList(qcResponse.getLocationFloors());
                    Helper.saveList(qcResponse.getLocationFloors(), Helper.homeFloor, getActivity());
                    locationFloorList.addAll(qcResponse.getLocationFloors());
                }

                if (!qcResponse.getLocationUnits().isEmpty()) {
                    // viewModel.setUnitList(qcResponse.getLocationUnits());
                    Helper.saveList(qcResponse.getLocationUnits(), Helper.homeUnit, getActivity());
                    locationUnitList.addAll(qcResponse.getLocationUnits());
                }

                Preference.setMyStringPref(Helper.project_file, Helper.firstTimeApiCall, getActivity(), "true");

            } else {
                Toast.makeText(getActivity(), "Fetching Records Failed", Toast.LENGTH_SHORT).show();
            }
        });

        if (Preference.getMyStringPref(Helper.project_file, Helper.firstTimeApiCall, getActivity()).equalsIgnoreCase("false") ||
                Preference.getMyStringPref(Helper.project_file, Helper.firstTimeApiCall, getActivity()).equalsIgnoreCase("default")) {

            Log.e("From-Service: ", "****");

            loginViewModel.getQualityControlData();
        } else {
            Log.e("From-Preference: ", "****");
            isFromPrevious = true;
            if (!Preference.getMyStringPref(Helper.project_file, Helper.departmentName, getActivity()).equalsIgnoreCase("default")) {
                locationSiteTextview.post(() -> locationSiteTextview.setText(Preference.getMyStringPref(Helper.project_file, Helper.locationSiteName, getActivity()), false));
            }

            if (!Preference.getMyStringPref(Helper.project_file, Helper.unitName, getActivity()).equalsIgnoreCase("default")) {
                unitTextview.post(() -> unitTextview.setText(Preference.getMyStringPref(Helper.project_file, Helper.unitName, getActivity()), false));
            }

            if (!Preference.getMyStringPref(Helper.project_file, Helper.floorName, getActivity()).equalsIgnoreCase("default")) {
                floorTextview.post(() -> floorTextview.setText(Preference.getMyStringPref(Helper.project_file, Helper.floorName, getActivity()), false));
            }

            departmentList.clear();
            locationSiteList.clear();
            locationUnitList.clear();
            locationFloorList.clear();

            //department list
            //departmentList.addAll(viewModel.getDepartmentList());
            departmentList.addAll(Helper.getList(Helper.homeDepartment, getActivity(), Department.class));
            //Log.e("departmentList-size: ", "" + departmentList.size());
            filteredList = new ArrayList<>(departmentList);
            // Set up filtered RecyclerView
            departmentItemAdapter = new DepartmentItemAdapter(filteredList, this, searchEditText, recyclerView);
            recyclerView.setLayoutManager(new LinearLayoutManager(getActivity()));
            recyclerView.setAdapter(departmentItemAdapter);

            //location list
            //locationSiteList.addAll(viewModel.getLocationSiteList());
            locationSiteList.addAll(Helper.getList(Helper.homeSite, getActivity(), LocationSite.class));
            //Log.e("locationSiteList-size: ", "" + locationSiteList.size());

            locationSitesAdapter = new LocationSitesAdapter(getActivity(), locationSiteList);
            locationSiteTextview.setAdapter(locationSitesAdapter);

            //unit list
            //locationUnitList.addAll(viewModel.getUnitList());
            locationUnitList.addAll(Helper.getList(Helper.homeUnit, getActivity(), LocationUnit.class));
            //Log.e("locationUnitList-size: ", "" + locationUnitList.size());

            //floor list
            //locationFloorList.addAll(viewModel.getFloorList());
            locationFloorList.addAll(Helper.getList(Helper.homeFloor, getActivity(), LocationFloor.class));
            //Log.e("locationFloorList-size: ", "" + locationFloorList.size());

            loadDropdownsOnBack();

            recyclerView.setVisibility(View.GONE);

        }
    }

    @Override
    public void onResume() {
        super.onResume();

        isFromPrevious = true;
        if (!Preference.getMyStringPref(Helper.project_file, Helper.departmentName, getActivity()).equalsIgnoreCase("default")) {
            searchEditText.setText(Preference.getMyStringPref(Helper.project_file, Helper.departmentName, getActivity()));
        }
    }

    public void showProgressDialog() {
        ProgressDialogFragment progressDialog = new ProgressDialogFragment();
        progressDialog.setCancelable(false);
        progressDialog.show(requireActivity().getSupportFragmentManager(), "progressDialog");
    }

    public void dismissProgressDialog() {
        ProgressDialogFragment progressDialog = (ProgressDialogFragment)
                requireActivity().getSupportFragmentManager().findFragmentByTag("progressDialog");
        if (progressDialog != null) {
            progressDialog.dismiss();
        }
    }

    private void filterList(String query) {
        if (filteredList != null) {
            filteredList.clear();
            if (query.isEmpty()) {
                // Hide the RecyclerView when there's no query
                recyclerView.setVisibility(View.GONE);
            } else {

                recyclerView.setVisibility(View.VISIBLE);

                for (Department item : departmentList) {
                    if (item.getTitle().toLowerCase().contains(query.toLowerCase())) {
                        filteredList.add(item);
                    }
                }
            }
            departmentItemAdapter.notifyDataSetChanged();

            if (isFromPrevious) {
                isFromPrevious = false;
                recyclerView.setVisibility(View.GONE);
            }

        }
    }

    @Override
    public void onItemClick(Department item) {
        //Toast.makeText(getActivity(), "Selected: " + item.getTitle(), Toast.LENGTH_SHORT).show();
        //viewModel.setDepartmentId(item.getId());
        Preference.setMyStringPref(Helper.project_file, Helper.departmentId, getActivity(), String.valueOf(item.getId()));
        Preference.setMyStringPref(Helper.project_file, Helper.departmentName, getActivity(), String.valueOf(item.getTitle()));
    }

    public boolean isValidate(String departId, String siteId, String unitId, String floorId) {
        boolean returnValue = true;
        String message = "";

        if (floorId.isEmpty() || floorId.equalsIgnoreCase("default")
                || floorTextview.getText().toString().equalsIgnoreCase("Select Floor")
                || floorTextview.getText().toString().isEmpty()) {
            message = "Please select Floor.";
            returnValue = false;
        }

        if (unitId.isEmpty() || unitId.equalsIgnoreCase("default")
                || unitTextview.getText().toString().equalsIgnoreCase("Select Unit")
                || unitTextview.getText().toString().isEmpty()) {
            message = "Please select Unit.";
            returnValue = false;
        }

        if (siteId.isEmpty() || siteId.equalsIgnoreCase("default")
                || locationSiteTextview.getText().toString().equalsIgnoreCase("")
                || locationSiteTextview.getText().toString().isEmpty()) {
            message = "Please select Location Site";
            returnValue = false;
        }

        if (departId.isEmpty() || departId.equalsIgnoreCase("default")
                || searchEditText.getText().toString().isEmpty()) {
            message = "Please select Department";
            returnValue = false;
        }

        if (!returnValue) {
            Toast.makeText(getActivity(), message, Toast.LENGTH_SHORT).show();
        }

        return returnValue;
    }

    public void loadDropdownsOnBack() {

        int locationSiteId;
        int unitId;

        //load unit dropdown
        if (!Preference.getMyStringPref(Helper.project_file, Helper.locationSiteId, getActivity()).equalsIgnoreCase("default")) {
            locationSiteId = Integer.parseInt(Preference.getMyStringPref(Helper.project_file, Helper.locationSiteId, getActivity()));

            if (!locationUnitList.isEmpty()) {
                List<LocationUnit> filteredUnitItems = locationUnitList.stream()
                        .filter(item -> Objects.equals(item.getSiteId(), locationSiteId))
                        .collect(Collectors.toList());

                locationUnitListFiltered.clear();
                locationUnitListFiltered.addAll(filteredUnitItems);
                unitAdapter = new UnitAdapter(getActivity(), filteredUnitItems);
                unitTextview.setAdapter(unitAdapter);

            }
        } else {
            locationSiteId = 0;
        }


        //load floor dropdown
        if (!Preference.getMyStringPref(Helper.project_file, Helper.unitId, getActivity()).equalsIgnoreCase("default")) {
            unitId = Integer.parseInt(Preference.getMyStringPref(Helper.project_file, Helper.unitId, getActivity()));

            if (!locationFloorList.isEmpty()) {
                List<LocationFloor> filteredFloorsList = locationFloorList.stream()
                        .filter(floor -> floor.getSiteId() == locationSiteId && Objects.equals(floor.getUnitId(), unitId))
                        .collect(Collectors.toList());

                locationFloorListFiltered.clear();
                locationFloorListFiltered.addAll(filteredFloorsList);
                floorAdapter = new FloorAdapter(getActivity(), filteredFloorsList);
                floorTextview.setAdapter(floorAdapter);
            }
        } else {
            unitId = 0;
        }


    }
}